Overview | Package | Class | Tree | Deprecated | Index | Help
| Xerces 1.2.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.xerces.dom
Class CharacterDataImpl

    java.lang.Object
      |
      +--org.apache.xerces.dom.NodeImpl
            |
            +--org.apache.xerces.dom.ChildNode
                  |
                  +--org.apache.xerces.dom.CharacterDataImpl

All Implemented Interfaces:
  java.lang.Cloneable, EventTarget, Node, NodeList, java.io.Serializable

Direct Known Subclasses:
  CommentImpl, ProcessingInstructionImpl, TextImpl

public abstract class CharacterDataImpl
extends ChildNode

CharacterData is an abstract Node that can carry character data as its Value. It provides shared behavior for Text, CData, and possibly other node types. All offsets are 0-based.

This implementation includes support for DOM Level 2 Mutation Events. If the static boolean NodeImpl.MUTATIONEVENTS is not set true, that support is disabled and can be optimized out to reduce code size. Since this ProcessingInstructionImpl inherits from this class to reuse the setNodeValue method, this class isn't declared as implementing the interface CharacterData. This is done by relevant subclasses (TexImpl, CommentImpl).

Since:
  PR-DOM-Level-1-19980818.
Version:
See Also:
  Serialized Form

Field Summary
`protected java.lang.String` | `data`

Fields inherited from class org.apache.xerces.dom.ChildNode
`nextSibling, previousSibling`

Fields inherited from class org.apache.xerces.dom.NodeImpl
`ELEMENT_DEFINITION_NODE, FIRSTCHILD, flags, IGNORABLEWS, MUTATION_AGGREGATE, MUTATION_ALL, MUTATION_LOCAL, MUTATION_NONE, MUTATIONEVENTS, OWNED, ownerNode, READONLY, SETVALUE, SPECIFIED, SYNCCHILDREN, SYNCDATA`

Fields inherited from interface org.w3c.dom.Node
`ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

Constructor Summary
`protected` | `CharacterDataImpl(DocumentImpl ownerDocument, java.lang.String data)` Factory constructor.

Method Summary
`void` | `appendData(java.lang.String data)` Concatenate additional characters onto the end of the data stored in this node.
`void` | `deleteData(int offset, int count)` Remove a range of characters from the node's value.
`NodeList` | `getChildNodes()` Returns an empty node list.
`java.lang.String` | `getData()` Retrieve character data currently stored in this node.
`int` | `getLength()` Report number of characters currently stored in this node's data.
`java.lang.String` | `getNodeValue()` Returns the node value.
`void` | `insertData(int offset, java.lang.String data)` Insert additional characters into the data stored in this node, at the offset specified.
`void` | `replaceData(int offset, int count, java.lang.String data)` Replace a series of characters at the specified (zero-based) offset with a new string, NOT necessarily of the same length.
`void` | `setData(java.lang.String value)` Store character data into this node.
`void` | `setNodeValue(java.lang.String value)` Sets the content, possibly firing related events, and updating ranges (via notification to the document)
`java.lang.String` | `substringData(int offset, int count)` Substring is more than a convenience function.

Methods inherited from class org.apache.xerces.dom.ChildNode
`cloneNode, getNextSibling, getParentNode, getPreviousSibling`

Methods inherited from class org.apache.xerces.dom.NodeImpl
`addEventListener, appendChild, changed, changes, dispatchEvent, getAttributes, getFirstChild, getLastChild, getLocalName, getNamespaceURI, getNodeName, getNodeType, getOwnerDocument, getPrefix, getReadOnly, getUserData, hasAttributes, hasChildNodes, insertBefore, isSupported, item, normalize, removeChild, removeEventListener, replaceChild, setPrefix, setReadOnly, setUserData, synchronizeData, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### data

    protected java.lang.String data

Constructor Detail

### CharacterDataImpl

    protected CharacterDataImpl(DocumentImpl ownerDocument,
                                java.lang.String data)

  Factory constructor.

Method Detail

### getChildNodes

    public NodeList getChildNodes()

  Returns an empty node list.
  Overrides:
    `getChildNodes` in class `NodeImpl`

### getNodeValue

    public java.lang.String getNodeValue()

  Description copied from class: `NodeImpl`
  Returns the node value.
  Overrides:
    `getNodeValue` in class `NodeImpl`
  Following copied from interface: `org.w3c.dom.Node`
  Throws:
    `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.
    `DOMException` - DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.

### setNodeValue

    public void setNodeValue(java.lang.String value)

  Sets the content, possibly firing related events, and updating ranges (via notification to the document)
  Overrides:
    `setNodeValue` in class `NodeImpl`
  Following copied from class: `org.apache.xerces.dom.NodeImpl`
  Throws:
    `DOMException(NO_MODIFICATION_ALLOWED_ERR)` -

### getData

    public java.lang.String getData()

  Retrieve character data currently stored in this node.
  Throws:
    `DOMExcpetion(DOMSTRING_SIZE_ERR)` - In some implementations, the stored data may exceed the permitted length of strings. If so, getData() will throw this DOMException advising the user to instead retrieve the data in chunks via the substring() operation.

### getLength

    public int getLength()

  Report number of characters currently stored in this node's data. It may be 0, meaning that the value is an empty string.
  Overrides:
    `getLength` in class `NodeImpl`
  Following copied from class: `org.apache.xerces.dom.NodeImpl`
  Returns:
    int
  See Also:
    `ParentNode`

### appendData

    public void appendData(java.lang.String data)

  Concatenate additional characters onto the end of the data stored in this node. Note that this, and insert(), are the paths by which a DOM could wind up accumulating more data than the language's strings can easily handle. (See above discussion.)
  Throws:
    `DOMException(NO_MODIFICATION_ALLOWED_ERR)` - if node is readonly.

### deleteData

    public void deleteData(int offset,
                           int count)
                    throws DOMException

  Remove a range of characters from the node's value. Throws a DOMException if the offset is beyond the end of the string. However, a deletion _count_ that exceeds the available data is accepted as a delete-to-end request.
  Throws:
    `DOMException(INDEX_SIZE_ERR)` - if offset is negative or greater than length, or if count is negative.
    `DOMException(NO_MODIFICATION_ALLOWED_ERR)` - if node is readonly.

### insertData

    public void insertData(int offset,
                           java.lang.String data)
                    throws DOMException

  Insert additional characters into the data stored in this node, at the offset specified.
  Throws:
    `DOMException(INDEX_SIZE_ERR)` - if offset is negative or greater than length.
    `DOMException(NO_MODIFICATION_ALLOWED_ERR)` - if node is readonly.

### replaceData

    public void replaceData(int offset,
                            int count,
                            java.lang.String data)
                     throws DOMException

  Replace a series of characters at the specified (zero-based) offset with a new string, NOT necessarily of the same length. Convenience method, equivalent to a delete followed by an insert. Throws a DOMException if the specified offset is beyond the end of the existing data.
  Parameters:
    `offset` - The offset at which to begin replacing.
    `count` - The number of characters to remove, interpreted as in the delete() method.
    `data` - The new string to be inserted at offset in place of the removed data. Note that the entire string will be inserted -- the count parameter does not affect insertion, and the new data may be longer or shorter than the substring it replaces.
  Throws:
    `DOMException(INDEX_SIZE_ERR)` - if offset is negative or greater than length, or if count is negative.
    `DOMException(NO_MODIFICATION_ALLOWED_ERR)` - if node is readonly.

### setData

    public void setData(java.lang.String value)
                 throws DOMException

  Store character data into this node.
  Throws:
    `DOMException(NO_MODIFICATION_ALLOWED_ERR)` - if node is readonly.

### substringData

    public java.lang.String substringData(int offset,
                                          int count)
                                   throws DOMException

  Substring is more than a convenience function. In some implementations of the DOM, where the stored data may exceed the length that can be returned in a single string, the only way to read it all is to extract it in chunks via this method.
  Parameters:
    `offset` - Zero-based offset of first character to retrieve.
    `count` - Number of characters to retrieve. If the sum of offset and count exceeds the length, all characters to end of data are returned.
  Throws:
    `DOMException(INDEX_SIZE_ERR)` - if offset is negative or greater than length, or if count is negative.
    `DOMException(WSTRING_SIZE_ERR)` - In some implementations, count may exceed the permitted length of strings. If so, substring() will throw this DOMException advising the user to instead retrieve the data in smaller chunks.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Xerces 1.2.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD